String clazzTpl({package}) => """
import 'package:flutter/material.dart';
import 'package:$package/widget/observable.dart';

enum ThemeType {
  dark,
  light,
}

class ThemeState {
  ThemeType type = ThemeType.dark;

  Color get title =>
      {ThemeType.dark: Colors.white, ThemeType.light: Color(0xff3c3f41)}[type]!;

  Color get body =>
      {ThemeType.dark: Color(0xff3c3f41), ThemeType.light: Colors.white}[type]!;
}

var observableTheme = Observable(ThemeState());

class ThemeBuilder extends StatelessWidget {
  const ThemeBuilder({
    Key? key,
    required this.builder,
  }) : super(key: key);

  final Widget Function(BuildContext, ThemeState) builder;

  @override
  Widget build(BuildContext context) =>
      observableTheme.builder(builder, memo: (theme) => [theme.type]);
}
""";
